#ifndef _GAMESLIST_H
#define _GAMESLIST_H 1

#include <glib.h>
#include <gtk/gtk.h>




#define GNOMAME_OK      0x01
#define GNOMAME_WARNING 0x02
#define GNOMAME_FATAL   0x04
#define GNOMAME_NOROM   0x08




typedef struct {
	gint row;
	gboolean haverc, marked;
	gint state;
   gchar *name;
   gchar *description;
   gchar *year;
   gchar *manufacturer;
   gchar *cloneof;
   GSList *errors;
} gamerecord;




GtkText      *info;
GtkWidget    *preview;
gamerecord   filter;
extern gamerecord *gnomame_selectedgame;
extern GSList *gnomame_mixerplugins, *gnomame_dspplugins;



void gnomame_init(GtkWidget *mainw);
void gnomame_query_xmame(GtkWidget *mainw);
void gnomame_exit(void);
void gnomame_error(gchar *msg, gint code);
gboolean gnomame_check_option(gchar *option);
void gnomame_goto_game(gchar *name);
void gnomame_play_game(gamerecord *game);
void gnomame_refresh_selected(void);
void gnomame_refresh_all(void);
void gnomame_refresh_game(gamerecord *g);
void gnomame_update_status(void);
void gnomame_load_games(void);
void gnomame_select_all(void);
void gnomame_unselect_all(void);
void gnomame_filter(void);
void gnomame_cycle_filter(GtkCList *l);
void gnomame_delrc(void);
void gnomame_show_info(GtkToggleButton *b, gamerecord *g, GtkText *info);
void gnomame_show_preview(GtkToggleButton *b, gamerecord *g, GtkWidget *pic);
void gnomame_show_help(gchar *arg);
void gnomame_mark_selected(GtkCList *notepad);
void gnomame_unmark_selected(GtkCList *notepad);
void gnomame_change_selection(GtkCList *l);
GList  *gnomame_give_availables(void);
GList  *gnomame_get_plugin_descriptions(GSList *l);
gchar  *gnomame_plugin_code(GSList *l, int i);
int  gnomame_plugin_code_to_num(GSList *l, gchar *code);

#endif
