#include "mdsgtkhelp.h"



extern const gchar *gtk_combo_string_key;




gint gtk_option_menu_get_history(GtkOptionMenu *OpMenu)

{
 GtkMenu *m;
 GtkWidget *active;
 GList *l;
 gint i;

 m = GTK_MENU(gtk_option_menu_get_menu(OpMenu));
 active = gtk_menu_get_active(m);
 for (i = 0, l = GTK_MENU_SHELL(m)->children; l; l = l->next, i++)
	 if (l->data == active) return (i);

 return (-1);
}




static gchar *combo_func(GtkListItem *li)

{
 GtkWidget *label;
 gchar *ltext = NULL;

 ltext = (gchar *) gtk_object_get_data (GTK_OBJECT (li), gtk_combo_string_key);
 if (!ltext) {
    label = GTK_BIN (li)->child;
    if (!label || !GTK_IS_LABEL (label)) return NULL;
    gtk_label_get (GTK_LABEL (label), &ltext);
 }
 return ltext;
}




gint gtk_combo_get_choice(GtkCombo *c)

{
 gint i;
 gchar *text, *ltext;
 GList *l;

 if (c->list) {
    text = gtk_entry_get_text(GTK_ENTRY(c->entry));
    l = GTK_LIST(c->list)->children;

    for (i = 0; l && l->data; l = l->next, i++) {
       ltext = combo_func(GTK_LIST_ITEM (l->data));
       if (!ltext) continue;
       if (strcmp(ltext, text) == 0) return (i);
    }
 }

 return (-1);
}





void gtk_combo_set_choice(GtkCombo *c, gint i)

{
 gchar *text, *ltext;
 GList *l;

 l = GTK_LIST(c->list)->children;
 text = combo_func(GTK_LIST_ITEM(l->data));

 for (; i && l && l->data; l = l->next, i--) ;
 ltext = combo_func(GTK_LIST_ITEM(l->data));
 if (ltext) text = ltext;
 if (text)  gtk_entry_set_text(GTK_ENTRY(c->entry), text);
}




gint gtk_clist_get_focus_row(GtkCList *clist)

{
 return (clist->focus_row);
}




void gtk_clist_set_focus_row(GtkCList *clist, gint row)

{
 if (!GTK_WIDGET_HAS_FOCUS(GTK_WIDGET(clist)))
	 gtk_widget_grab_focus(GTK_WIDGET(clist));
 gtk_widget_draw_focus(GTK_WIDGET(clist));
 clist->focus_row = row;
 gtk_widget_draw_focus(GTK_WIDGET(clist));
}




gint gtk_clist_row_get_first(GtkCList *clist)

{
 gint row, col;

 if (gtk_clist_get_selection_info(clist, 0, 0, &row, &col))
	 return (row);
 else
	 return (-1);
}





gboolean gtk_clist_row_is_selected(GtkCList *clist, gint row)

{
 GtkCListRow *r;

 r = (GtkCListRow *) (g_list_nth(clist->row_list, row)->data);
 return (r->state == GTK_STATE_SELECTED);
}
