#ifndef _PREFERENCES_H
#define _PREFERENCES_H 1

#include <glib.h>
#include "core.h"


typedef struct {
	int      toolbartype;
	int		status;
   gchar    *xmamepath;
   gchar    *previewdir;
   gboolean showinfo, showpreview;
	gboolean confirmplay;
	gboolean showcol[4];
	GSList   *marked;
} gnomameprefs;



#define XMAMEPREF_TYPE_NONE    '0'
#define XMAMEPREF_TYPE_BOOL    'B'
#define XMAMEPREF_TYPE_INT     'I'
#define XMAMEPREF_TYPE_FLOAT   'F'
#define XMAMEPREF_TYPE_STRING  'S'
#define XMAMEPREF_TYPE_LIST    'L'
#define XMAMEPREF_TYPE_FLAG    'X'

#define XMAMEPREF_WTYPE_NONE   '0'
#define XMAMEPREF_WTYPE_TOGGLE '1'
#define XMAMEPREF_WTYPE_SPIN   '2'
#define XMAMEPREF_WTYPE_SCALE  '3'
#define XMAMEPREF_WTYPE_ENTRY  '4'
#define XMAMEPREF_WTYPE_CLIST  '5'
#define XMAMEPREF_WTYPE_COMBO  '6'
#define XMAMEPREF_WTYPE_GNUMBR '7'
#define XMAMEPREF_WTYPE_OPMENU '8'



typedef struct {
	gchar *name;
	char type;
	char widgtype;
	gboolean valid;          /* TRUE if xmame support it */
	gchar *depend;           /* From what option it depend */
	gboolean negative;       /* TRUE means ! and FALSE means = */
	gint condvalue;          /* only integer value allowed */
} xmameprefrule;



typedef struct {
	xmameprefrule *r;
	union {
		gboolean b;
		int i;
		double f;
		char *s;
		GSList *l;
   } val;
} xmamepref;



typedef struct {
	gamerecord *g;
	gchar *rcfilename;
	GSList *prefs;           /* A list of xmamepref */
} xmameprefs;




gnomameprefs *gnomamerc;



void xmameprefs_loadrules(void);
xmameprefrule *xmameprefrule_get(int i);
xmameprefrule *xmameprefrule_find(gchar *name);

xmamepref *xmameprefs_add(xmameprefs *prefs, xmameprefrule *r);
void       xmameprefs_del(xmameprefs *prefs, xmamepref *p);
xmamepref *xmameprefs_find(xmameprefs *p, gchar *name);

xmameprefs *xmameprefs_read(gamerecord *g);
void        xmameprefs_write(xmameprefs *prefs);
void        xmameprefs_free(xmameprefs *prefs);
void        xmameprefs_delrc(gamerecord *g);

gnomameprefs *gnomameprefs_read(void);
void          gnomameprefs_write(gnomameprefs *prefs);
void          gnomameprefs_free(gnomameprefs *prefs);

#endif
